public class BWPixelIcon {
    String c;
    int w;
    public BWPixelIcon(String content, int width) {
        c = content;
        w = width;
    }

    public void draw(JGrafikPanel b, int x, int y) {
        int row = 0;
        int col = 0;
        for(int i = 0; i<c.length(); i++) {
            if(c.charAt(i) != ' ') {
                b.setPixel(x+col,y+row,true);
            } else {
                b.setPixel(x+col,y+row,false);
            }
            col++;
            if(col >= w) {
                col = 0;
                row++;
            }
        }
    }

    public void drawNFach(JGrafikPanel b, int x, int y, int n) {
        int row = 0;
        int col = 0;
        for(int i = 0; i<c.length(); i++) {
            if(c.charAt(i) != ' ') {
                for(int kx = 0; kx < n; kx++) {
                    for(int ky = 0; ky < n; ky++) {
                        b.setPixel(x+kx+col,y+ky+row,true);
                    }
                }
            } else {
                for(int kx = 0; kx < n; kx++) {
                    for(int ky = 0; ky < n; ky++) {
                        b.setPixel(x+kx+col,y+ky+row,false);
                    }
                }
            }
            col = col + n;
            if(col >= (w*n)) {
                col = 0;
                row = row + n;
            }
        }
    }
}
