import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Scanner;

/*
 * GUI (Graphical User Interface), mit einem eigenen Layout
 */
public class BilderGUI implements ActionListener,  MouseMotionListener, ChangeListener  {
    JButton but1;
    JLabel lab1;
    JGrafikPanel bild1;
    JSpinner spinner;
    JFrame frame; 

    int counter = 0;
    int spinnerValue = 0;

    BWPixelIcon baumteil;
    BWPixelIcon smiley;
    ValuePixelIcon figur;

    public void zeigeFenster() {
        setSchriftgroesse(18);

        frame = new JFrame();
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        frame.setTitle("MatheBilder");
        frame.setLayout(null); 

        bild1 = new JGrafikPanel(500,500);
        bild1.setBounds(10,80,500,500);
        frame.add(bild1);

        //                                            inival, min, max, step
        SpinnerNumberModel model = new SpinnerNumberModel(0, -1000, 1000, 1);
        spinner = new JSpinner(model);
        spinner.setBounds(110,50,100,30);
        spinner.addChangeListener(this);
        frame.add(spinner);

        but1 = new JButton("Klick!");
        but1.setBounds(10,10,120,40);
        but1.addActionListener(this);
        frame.add(but1);

        lab1 = new JLabel("Parameter ");
        lab1.setBounds(10,50,100,30);
        frame.add(lab1);

        frame.pack();
        frame.setSize(700,630);
        frame.setResizable(false);
        frame.setVisible( true );

        String icContent = ""+
            "         ######       ####         "+
            "     ####     ###   ##    ####     "+
            "    #            # #          ##   "+
            "   #              #             #  "+
            "  #        #                   # # "+
            "  #       #    # #     # #    # ## "+
            "  #   # # ##  # #    #  #   ## # # "+
            "   #   # #  #  ##  ## #   ##  ###  "+
            "   #  ###   # ## # ##  # ###   #   "+
            "    ##       ##   ##    ###        "+
            "";

        baumteil = new BWPixelIcon(icContent,35);

        icContent = ""+
            "   ++++   "+
            " ++    ++ "+
            "+        +"+
            "+  +  +  +"+
            "+        +"+
            "+ +    + +"+
            "+  ++++  +"+
            " ++    ++ "+
            "   ++++   ";

        smiley = new BWPixelIcon(icContent,10);

        //  .:-+#
        icContent = ""+
        "                "+
        "  ############  "+
        " #------------# "+
        "#--++++++++++--#"+
        "#-+##########+-#"+
        "#-#::::::::::#-#"+
        "#-#:.#....#.:#-#"+
        "##:..#....#..:##"+
        "#:...#....#...:#"+
        "#....#....#....#"+
        "#..............#"+
        " #............# "+
        " ############## "+
        "#::#++++++++#::#"+
        "#.#+--------#.# "+
        " #############  "+
        "  #++---#+---#  "+
        "";

        figur = new ValuePixelIcon(icContent,16);

    }

    public void baum(JGrafikPanel p, int x, int y) {
            for(int i = 0; i<65; i++ ) {
                bild1.setPixel(x+0, y+i, true);
                bild1.setPixel(x+1, y+i, true);
                bild1.setPixel(x+2, y+i, true);
                bild1.setPixel(x+3, y+i, true);
                bild1.setPixel(x+4, y+i, true);
            }
            baumteil.draw(p,x-15 + 0 ,y + 0);
            baumteil.draw(p,x-15 + 15,y + 10);
            baumteil.draw(p,x-15 - 10,y + 17);
            baumteil.draw(p,x-15 - 5 ,y + 30);
            baumteil.draw(p,x-15 + 20,y + 26);
            baumteil.draw(p,x-15 + 2 ,y + 45);
            
        
    }
    
    public void actionPerformed(ActionEvent e) {
        if(e.getSource() == but1) {
            int z1 = (int) (Math.random() * 500);
            int z2 = (int) (Math.random() * 500);
            
            baum(bild1,115,150);
            baum(bild1,190,150);
            baum(bild1,240,150);
            baum(bild1,300,150);
                
                        
            figur.draw(bild1, z1 , z2);

            
            /*
            int qwidth = 10;
            for(int i = 0; i < qwidth; i++) {
            bild1.setPixel(z1+i, z2, true);
            bild1.setPixel(z1, z2+i, true);
            bild1.setPixel(z1+i, z2+qwidth, true);
            bild1.setPixel(z1+qwidth, z2+i, true);

            bild1.setPixel(z1+i, z2+1, true);
            bild1.setPixel(z1+1, z2+i, true);
            bild1.setPixel(z1+i, z2+qwidth+1, true);
            bild1.setPixel(z1+qwidth+1, z2+i, true);

            }
             */

            /*
            // Bereich negativ (bw-wechsel) machen
            for(int x = 200; x < 250; x++) {
                for(int y = 100; y < 300; y++) {
                    boolean pixel = bild1.getPixel(x,y);
                    bild1.setPixel(x, y, !pixel);
                }
            }

            smiley.draw(bild1,z1,z2);
            gradient.draw(bild1,z1+30,z2);
            */
            counter++;
        }

        frame.repaint();
    }

    public void stateChanged(ChangeEvent e) {
        SpinnerNumberModel spinnerModel = (SpinnerNumberModel) spinner.getModel();
        spinnerValue = spinnerModel.getNumber().intValue();
        frame.repaint();      
    }    

    public void mouseMoved(MouseEvent e) {
        //StaticDraw.wert1 =e.getX();
        //StaticDraw.wert2 =e.getY();
        //System.out.println("mouse Moved! "+StaticDraw.wert1 + " " + StaticDraw.wert2);
        frame.repaint();
    }

    public void mouseDragged(MouseEvent e) {
        // nichts tun, wenn "klicken+ziehen" passiert?
    }    

    public static boolean isInt(String s) {
        Scanner sc = new Scanner(s.trim());
        if(!sc.hasNextInt(10)) return false;
        // we know it starts with a valid int, now make sure
        // there's nothing left!
        sc.nextInt(10);
        return !sc.hasNext();
    }

    void setSchriftgroesse(int s) {
        Font f = new Font("Arial", Font.BOLD, s);

        UIManager.put("Button.font",f);
        UIManager.put("ToggleButton.font",f);
        UIManager.put("RadioButton.font", f);
        UIManager.put("CheckBox.font", f);
        UIManager.put("ColorChooser.font", f);
        UIManager.put("ComboBox.font", f);
        UIManager.put("Label.font",f);
        UIManager.put("List.font", f);
        UIManager.put("MenuBar.font", f);
        UIManager.put("MenuItem.font", f);
        UIManager.put("RadioButtonMenuItem.font", f);
        UIManager.put("CheckBoxMenuItem.font", f);
        UIManager.put("Menu.font", f);
        UIManager.put("PopupMenu.font", f);
        UIManager.put("OptionPane.font", f);
        UIManager.put("Panel.font", f);
        UIManager.put("ProgressBar.font", f);
        UIManager.put("ScrollPane.font", f);
        UIManager.put("Viewport.font", f);
        UIManager.put("TabbedPane.font", f);
        UIManager.put("Table.font", f);
        UIManager.put("TableHeader.font", f);
        UIManager.put("TextField.font", f);
        UIManager.put("PasswordField.font", f);
        UIManager.put("TextArea.font", f);
        UIManager.put("TextPane.font", f);
        UIManager.put("EditorPane.font", f);
        UIManager.put("TitledBorder.font", f);
        UIManager.put("ToolBar.font", f);
        UIManager.put("ToolTip.font", f);
        UIManager.put("Tree.font", f);        
    }

}