public class ValuePixelIcon {
    String c;
    int w;
    public ValuePixelIcon(String content, int width) {
        c = content;
        w = width;
    }
    
    // 6 Helligkeitswerte:
    //  .:-+#
    public void draw(JGrafikPanel b, int x, int y) {
        int i = 0;
        int row = 0;
        int col = 0;
        while(i < c.length()) {
            char zeichen = c.charAt(i);
            int value = 0;
            if(zeichen == ' ') {
                value = 255;
            }
            if(zeichen == '.') {
                value = 200;
            }
            if(zeichen == ':') {
                value = 150;
            }
            if(zeichen == '-') {
                value = 100;
            }
            if(zeichen == '+') {
                value = 50;
            }
            if(zeichen == '#') {
                value = 0;
            }
            
            b.setPixelValue(x+col,y+row,value);
                
            i++;
            col++;
            if(col >= w) {
                col = 0;
                row++;
            }
        }
    }
}
